gcc-plugins: move GCC version check for PowerPC to Kconfig
[linux-2.6-block.git] / scripts / Makefile.gcc-plugins
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
6b90bd4b
ER
2ifdef CONFIG_GCC_PLUGINS
3 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
4 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
5
543c37cb
ER
6 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
7
0dae776c 8 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
543c37cb 9
38addce8
ER
10 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
11 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
7b4010ed 12 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
38addce8
ER
13 DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
14 endif
15
543c37cb 16 ifdef CONFIG_GCC_PLUGIN_SANCOV
543c37cb
ER
17 # It is needed because of the gcc-plugin.sh and gcc version checks.
18 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
19
5aadfdeb 20 ifeq ($(PLUGINCC),)
543c37cb
ER
21 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
22 endif
543c37cb
ER
23 endif
24
c61f13ea
KC
25 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
26 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
f7dd2507 27 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_BYREF_ALL) += -fplugin-arg-structleak_plugin-byref-all
c61f13ea
KC
28 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
29
313dd1b6
KC
30 gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
31 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
32 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
33
65d59ec8 34 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
6b90bd4b 35
38addce8 36 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
5aadfdeb 37 export DISABLE_LATENT_ENTROPY_PLUGIN
6b90bd4b 38
ed58c0e9
KC
39 ifneq ($(PLUGINCC),)
40 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
41 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
42 endif
43
44 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
45 GCC_PLUGIN := $(gcc-plugin-y)
caefd8c9 46 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
ed58c0e9
KC
47endif
48
49# If plugins aren't supported, abort the build before hard-to-read compiler
50# errors start getting spewed by the main build.
51PHONY += gcc-plugins-check
52gcc-plugins-check: FORCE
53ifdef CONFIG_GCC_PLUGINS
6b90bd4b
ER
54 ifeq ($(PLUGINCC),)
55 ifneq ($(GCC_PLUGINS_CFLAGS),)
56 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
ed58c0e9
KC
57 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
58 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
6b90bd4b 59 else
ed58c0e9 60 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
6b90bd4b
ER
61 endif
62 endif
63 endif
ed58c0e9
KC
64endif
65 @:
6b90bd4b 66
ed58c0e9
KC
67# Actually do the build, if requested.
68PHONY += gcc-plugins
69gcc-plugins: scripts_basic gcc-plugins-check
70ifdef CONFIG_GCC_PLUGINS
71 $(Q)$(MAKE) $(build)=scripts/gcc-plugins
6b90bd4b 72endif
ed58c0e9 73 @: